.TH "Crossroads" "2005"
.PP
.SH "Crossroads"
.SH "Karel Kubat"
.SH "e-tunity"
.SH "2005"

.PP 

.SH "1: Introduction"
Crossroads is a daemon that basically accepts TCP connections
at preconfigured ports, and given a list of \&'back ends\&'
distributes each incoming connection, so that a client process is
served\&. Additionally, crossroads maintains an internal
administration of the back end connectivity: if a back end isn\&'t
usable, then the client request is handled using another back
end\&. Crossroads will then periodically check whether a previously not
usable  back end has come to life yet\&. Also, crossroads can select
back ends by estimating the load, so that balancing is achieved\&.
.PP 
Using this approach, crossroads serves as load balancer and fail over
utility\&. Crossroads will very likely not be as reliable as
hardware based balancers, since it always will require a server to
run on\&. This server, in turn, may become a new Single Point of
Failure (SPOS)\&.  However, in situations where cost efficiency is an issue,
crossroads may be a good choice\&. Furthermore, crossroads can be
deployed in situations where a hardware based balancing already
exists and augmenting service reliability is needed\&. Or, crossroads may be
run off a diskless system, which again improves reliability of the
underlying hardware\&.
.PP 
This document describes how to use crossroads, how to configure it
in order to increase the reliability of your systems, and how to
compile the program from its sources\&. 
.PP 

.SH "1\&.1: Obtaining Crossroads"

.PP 
As quick reference, here are some important URL\&'s for Crossroads:
.PP 
.IP o 
http://public\&.e-tunity\&.com is the site that serves
Crossroads and other packages\&. You can browse this at leisure
for documentation, sources, and so on\&.
.IP 
.IP o 
http://public\&.e-tunity\&.com/crossroads/crossroads-latest\&.tar\&.gz is
the \&'latest\&' distribution archive\&. Instead of \fIlatest\fP you
can substitute a specific version, such as \fI0\&.07\fP\&. Too many
older versions however aren\&'t stored\&.
.IP 
.IP o 
http://public\&.e-tunity\&.com/crossroads/crossroads\&.html is
the documentation in HTML format (this text)\&. Substitute
\fI\&.pdf\fP for \fI\&.html\fP to get the documentation in PDF format\&.
.PP 

.SH "1\&.2: Copyright and Disclaimer"

.PP 
Crossroads is distributed as-is, without assumptions of fitness
or usability\&. You are free to use crossroads to your
liking\&. It\&'s free, and as with everything that\&'s free: there\&'s
also no warranty\&.
.PP 
You are allowed to make modifications to the source code of
crossroads, and you are allowed to (re)distribute crossroads, as
long as you include this text, all sources, and if applicable: all
your modifications, with each distribution\&.
.PP 
While you are allowed to make any and all changes to the sources,
I would appreciate hearing about them\&. If the changes concern new
functionality or bugfixes, then I\&'ll include them in a next
release, stating full credits\&.
.PP 

.SH "1\&.3: Terminology"

.PP 
Throughout this document, the following terms are used: \e (Many
more meanings of the terms will exist -- yes, I am aware of that\&. I\&'m
using the terms here in a very strict sense\&.)
.PP 
.IP "A client"
is a process that initiates a network connection
to get contact with some service\&. 
.IP "A service"
or \fBserver process\fP is a central application
that accepts network connections from clients and sevices
them\&. Based on its configuration, crossroads will start
one or more services that wait for clients to connect\&.
.IP "Back ends"
are locations where crossroads looks in
order to service its clients\&. Crossroads sits \&'in between\&'
and does its tricks\&. Therefore, as far as the back ends
are concerned, crossroads behaves like a client\&. As far as
the true client is concerned, crossroads behaves like the
service\&. The communication is however transparent: neither
client nor back end are aware of the middle position of
crossroads\&.
.IP "A session"
is a conversation between client and service,
where data are transferred to and fro over the network\&. As
far as crossroads is concerned, a session is succesful if
connections are succesfully established and no errors on
the network level occur\&. Crossroads isn\&'t aware of service
pecularities\&. E\&.g\&., when a webserver answers \f(CWHTTP/1\&.0
500 Server Error\fP then crossroads will see this as a
succesful session, though the user behind a browser may
think otherwise\&.
.IP "Listeners"
are programs that listen to a given TCP
port\&. Based on its configuration, crossroads starts a
listener for each service\&.
.IP "Back end selection algorithms"
are methods by which
crossroads determines which back end it will talk to
next\&. Crossroads has a number of built-in algorithms,
which are configured per service\&.
.IP "Back end states"
are the statusses of each back end that
is known to crossroads\&. A back end may be available,
(temporarily) unavailble or truly down\&. When a back end is
temporarily unavailable, then crossroads will periodically
check whether the back end has come to life yet (that is,
if configured so)\&.
.IP "Load balancing"
means that an incoming client request is
distributed over not just one back end (which would be the
case if you wouldn\&'t be running crossroads)\&. Enabling load
balancing is nothing more than duplicating services over
more than one back end, and having something (in this
case: crossroads) distribute the requests, so that per
back end the load doesn\&'t get too high\&.
.IP "Back end usage"
is measured by crossroads in order to be
able to determine back end selection\&. Crossroads stores
information about the number of transferred bytes and
about the session duration\&. These numbers can be used to
estimate which back end is the least used -- and
therefore, presumably, the best candidate for a new
request\&.
.IP "Fail over"
is almost always used when load balancing is in
effect\&. The distributor of client requests (crossroads of
course) can also monitor back ends, so that incase a back
end is \&'down\&', it is no longer accessed\&.
.IP "Service downtime"
normally occurs when a service is
switched off\&. Downtime is obviously avoided when fail over
is in effect: a back end can be taken out of service in a
controlled manner, without any client noticing it\&.

.PP 

.SH "2: Using Crossroads"
Crossroads is started from the commandline, and highly depends on
\f(CW/etc/crossroads\&.conf\fP (the default configuration file)\&. It 
supports a number of flags (e\&.g\&., to overrule the location of the
configuration file)\&. The actual usage information is always obtained
by typing \f(CWcrossroads\fP without any arguments\&. Crossroads then
displays the allowed arguments\&. 
.PP 
This section shows the basic usage\&.
.PP 
.IP o 
\f(CWcrossroads start\fP and \f(CWcrossroads stop\fP are typical
actions that are run from system startup scripts\&. The
meaning is self-explanatory\&.
.IP o 
\f(CWcrossroads restart\fP is a combination of the former
two\&. Beware that a restart may cause discontinuity in
service; it is just a shorthand for typing the \&'stop\&' and
\&'start\&' actions after one another\&.
.IP o 
\f(CWcrossroad status\fP reports on each running
service\&. Per service, the state of each back end is
reported\&.
.IP o 
\f(CWcrossroads tell\fP \fIservice backend state\fP is a
command line way of telling crossroads that a given back
end, of a given service, is in a given state\&. Normally
crossroads maintains state information itself, but by
using \f(CWcrossroads tell\fP, a back end can be e\&.g\&. taken
\&'off line\&' for servicing\&.
.IP o 
\f(CWcrossroads services\fP reports on the configured
services\&. In contrast to \f(CWcrossroads status\fP, this
option only shows what\&'s configured -- not what\&'s up and
running\&. Therefore, \f(CWcrossroads services\fP doesn\&'t
report on back end states\&.
.IP o 
\f(CWcrossroads sampleconf\fP shows a sample configuration on
screen\&. A good way of quicky viewing the configuration
file syntax, or of getting a start for your own
configuration \f(CW/etc/crossroads\&.conf\fP\&.

.PP 

.SH "3: The configuration"
The configuration that crossroads uses is normally stored in the file
\f(CW/etc/crossroads\&.conf\fP\&. This location can be overruled using the
command line flag \f(CW-c\fP\&.
.PP 
This section explains the syntax of the configuration file, and what
all settings do\&.
.PP 

.SH "3\&.1: General language elements"

.PP 
This section describes the general elements of the crossroads
configuration language\&.
.PP 

.SH "3\&.1\&.1: Empty lines and comments"

.PP 
Empty lines are of course allowed in the
configuration\&. Crossroads recognizes three formats of comment:
.PP 
.IP o 
C-style, between \f(CW/*\fP and \f(CW*/\fP,
.IP o 
C++-style, starting with \f(CW//\fP and ending with the end
of the text line;
.IP o 
Shell-style, starting with \f(CW#\fP and ending with the end
of the text line\&.
.PP 
Simply choose your favorite editor and use the comment that \&'looks
best\&'\&.\e (I favor C or C++ comment\&. My favorite editor \fIemacs\fP
can be put in \f(CWcmode\fP and nicely highlight what\&'s comment and what\&'s
not\&. And as a bonus it will auto-indent the configuration!)
.PP 

.SH "3\&.1\&.2: Keywords, numbers, identifiers, generic strings"

.PP 
In a configuration file, statements are identified by \fIkeywords\fP,
such as \f(CWservice\fP, \f(CWverbosity\fP\&. These are reserved words\&.
.PP 
Many keywords require an \fIidentifier\fP as the argument\&. E\&.g, a
service has a unique name, which must start with a letter or
underscore, followed by zero or more letters, underscores, or
digits\&. E\&.g\&., in the statement \f(CWservice myservice\fP, the keyword is
\f(CWservice\fP and the identifier is \f(CWmyservice\fP\&.
.PP 
Other keywords require a numeric argument\&. Crossroads knows only
non-negative integer numbers, as in \f(CWport 8000\fP\&. Here, \f(CWport\fP is
the keyword and \f(CW8000\fP is the number\&.
.PP 
Yet other keywords require \&'generic strings\&', such as hostname
specifications or system commands\&. Such generic strings contain any
characters up to the terminating statement character \f(CW;\fP\&.
.PP 
Finally, an argument can be a \&'boolean\&' value\&. Crossroads knows
\f(CWtrue\fP, \f(CWfalse\fP, \f(CWyes\fP, \f(CWno\fP, \f(CWon\fP, \f(CWoff\fP\&. The keywords
\f(CWtrue\fP, \f(CWyes\fP and \f(CWon\fP all mean the same and can be used
interchangeably; as can the keywords \f(CWfalse\fP, \f(CWno\fP and \f(CWoff\fP\&.
.PP 

.SH "3\&.2: Service definitions"

.PP 
Service definitions are blocks in the configuration file that
state what is for each service\&. A service definition starts with
\f(CWservice\fP, followed by a unique identifier, and by statements in
\f(CW{\fP and \f(CW}\fP\&. For example:
.PP 
.nf 
// Definition of service \&'www\&':
service www {
    \&.\&.\&.
    \&.\&.\&. // statements that define the
    \&.\&.\&. // service named \&'www\&'
    \&.\&.\&.
}
.fi 

.PP 
The following list shows possible stateements\&.
.PP 
.IP "Service definition statements"
define what a service should
do\&. Possible definition statements are shown below\&. Each statement is
terminated by a semicolon (except for the \f(CWbackend\fP statement, which
has its own block)\&.
.IP 
.IP "The port statement"
defines to which TCP port a service
\&'listens\&'\&. E\&.g\&. \f(CWport 8000\fP says that this service will accept
connections on port 8000\&.
.IP 
.IP o 
Syntax: \f(CWport\fP \fInumber\fP \f(CW;\fP
.IP o 
There is no default\&. This is a required setting\&.
.IP 
.IP "The bindto statement"
is used in situations where crossroads
should only listen to the stated port at a given IP address\&. E\&.g\&.,
\f(CWbindto 127\&.0\&.0\&.1\fP causes crossroads to \&'bind\&' the service only to
the local IP address\&. Network connections from other hosts won\&'t be
serviced\&. By default, crossroads binds a service to all presently
active IP addresses at the invoking host\&.
.IP 
.IP o 
Syntax: \f(CWbindto\fP \fIip-address\fP \f(CW;\fP
.IP o 
where \fIip-address\fP is a numeric IP address, such as
\f(CW192\&.168\&.1\&.45\fP, or the keyword \f(CWany\fP
.IP o 
Default: \f(CWany\fP
.IP 
.IP "Verbosity statements"
come in two forms: \f(CWverbosity on\fP or
\f(CWverbosity off\fP\&. When \&'on\&', log messages to \f(CW/var/log/messages\fP
are generated that show what\&'s going on\&.\e (Actually, the
messages go to \f(CWsyslog(3)\fP, using facility \f(CWLOG_DAEMON\fP and
priority \f(CWLOG_INFO\fP\&. In most (Linux) cases this will mean: output to
\f(CW/var/log/messages\fP\&.)
.IP 
.IP o 
Syntax: \f(CWverbosity\fP \fIsetting\fP \f(CW;\fP
.IP o 
where \fIsetting\fP is \f(CWtrue\fP, \f(CWyes\fP or \f(CWon\fP to turn
verbosity on; or \f(CWfalse\fP, \f(CWno\fP, \f(CWoff\fP to turn it off\&.
.IP o 
Default: \f(CWoff\fP\&.
.IP 
.IP "The dispatch mode"
controls how crossroads selects a back end from
a list of active back ends\&. The syntax is:
.IP 
.IP o 
\f(CWdispatchmode roundrobin\fP: Simply the \&'next in line\&' is
chosen\&. E\&.g, when 3 back ends are active, then the usage
series is 1, 2, 3, 1, 2, 3, and so on\&.
.IP 
Roundrobin dispatching is the default method, when no
\f(CWdispatchmode\fP statement occurs\&.
.IP 
.IP o 
\f(CWdispatchmode random\fP: Random selection\&. Probably only
for stress testing\&.
.IP 
.IP o 
\f(CWdispatchmode bysize [ over\fP \fIsessions\fP \f(CW]\fP:
The next back end is the one
that has transferred the least number of bytes\&. This
selection mechanism assumes that the more bytes, the heavier
the load\&.
.IP 
The modifier \f(CWover\fP \fInsessions\fP is optional\&. (The square
brackets shown above are not part of the statement but
indicate optionality\&.)  When given,
the size load is computed over the last stated number of
sessions\&. When this modifier is absent, then the load is
computed over all sessions since startup\&.
.IP 
.IP o 
\f(CWdispatchmode byduration [ over\fP \fIsessions\fP \f(CW]\fP:
The next back end is the one
that served sessions for the shortest time\&. This mechanims
assumes that the longer the session, the heavier the load\&.
.IP 
.IP o 
\f(CWdispatchmode byorder\fP: The first back end is selected
every time, unless it\&'s unavailable\&. In that case the second
is taken, and so on\&.
.IP 
The \&'right\&' dispatch mode will depend on the type of service\&. Given
the fact that crossroads doesn\&'t know (and doesn\&'t care) what a stream
of network traffic means, you have to choose an appropriate dispatch
mode to optimize load balancing\&. Note that the dispatch mode is
totally irrelevant when your only concern is fail over\&. In most cases,
\f(CWroundrobin\fP will do the job just fine\&.
.IP 
.IP "A reviving interval definition"
is needed when crossroads
determines that a back end is temporarily unavailable\&. This will
happen when: 
.IP 
.IP o 
The back end cannot be reached (network connection
fails);
.IP o 
The network connection to the back end suddenly dies\&.
.IP 
An example of the definition is \f(CWrevivinginterval 10\fP\&. When this
reviving interval is given, crossroads will check each 10 seconds
whether unavailable back ends have woken up yet\&. A back end is
considered awake when a network connection to that back end can
succesfully be established\&.
.IP 
.IP o 
Syntax: \f(CWrevivinginterval\fP \fInumber\fP \f(CW;\fP
.IP o 
Default: 0, meaning no revivals will occur\&.
.IP 
.IP "The maximum number of clients"
is specified using
\f(CWmaxclients\fP\&. There is one argument; the number of concurrent
established sessions that may be active within one service\&.
.IP 
\&'Throttling\&' the number of clients is a way of preventing Denial of
Service (DOS) attacks\&. Without a limit, numerous network connections
may spawn so many server instances, that the service ultimately breaks
down and becomes unavailable\&.
.IP 
.IP o 
Syntax: \f(CWmaxclient\fP \fInumber\fP \f(CW;\fP
.IP o 
Default: 0, meaning that all client connections will be
accepted\&. 
.IP 
.IP "The TCP back log size"
is a number that controls how many
\&'waiting\&' network connections may be queued, before a client simply
cannot connect\&. The syntax is e\&.g\&. \f(CWbacklog 5\fP to cause crossroads
to have 5 waiting connections for 1 active session\&.
The backlog queue shouldn\&'t be too
high, or clients will experience timeouts before they can actually
connect\&. The queue shouldn\&'t be too small either, because clients
would be simply rejected\&. Your mileage may vary\&.
.IP 
.IP o 
Syntax: \f(CWbacklog\fP \fInumber\fP \f(CW;\fP
.IP o 
Default: zero, which takes the operating system\&'s default
value for socket back log size\&.
.IP 
.IP "Reporting based: the shared memory key\&."
Different crossroad
invocations must \&'know\&' of each others activity\&. E\&.g, \f(CWcrossroad
status\fP must be able to get to the actual state information of all
running services\&. This is internally implemented through shared
memory, which is reserved using a key\&.
.IP 
Normally crossroads will supply a shared memory key, based on the
service port and bitwise or-ed with a magic number\&. In situations
where this conflicts with existing keys (of other programs, having
their own keys), you may supply a chosen value\&.
.IP 
The syntax is e\&.g\&. \f(CWshmkey
123456\fP\&. The actual key value doesn\&'t matter much, as long as it\&'s
unique and as long as each invocation of crossroads uses
it\&.
.IP 
.IP o 
Syntax: \f(CWshmkey\fP \fInumber\fP \f(CW;\fP
.IP o 
Default: 0, which means that crossroads will \&'guess\&' its
own key, based on TCP port and a magic number\&.
.IP 
.IP "Session timeouts:"
Sometimes, clients simply won\&'t close a network
connection which leads to unnecessary resource usage\&. To avoid this,
one might state \f(CWsessiontimeout 300\fP\&. This instructs crossroads to
consider a session where nothing has happened for 300 seconds as
\&'finished\&'\&. Crossroads will terminate the connection when this timeout
is exceeded\&.
.IP 
.IP o 
Syntax: \f(CWsessiontimeout\fP \fInumber\fP \f(CW;\fP
.IP o 
Default: 0, meaning that crossroads will not try to
determine timeouts\&.
.IP 

.SH "3\&.3: Backend definitions"

.PP 
Inside the service definitions as are described in the previous
section, \fIbackend definitions\fP must also occur\&. Backend definitions
are started by the keyword \f(CWbackend\fP, followed by an identifier, and
defining statements inside \f(CW{\fP and \f(CW}\fP:
.PP 
.nf 
service myservice {
    \&.\&.\&.
    \&.\&.\&. // statements that define the
    \&.\&.\&. // service named \&'myservice\&'
    \&.\&.\&.

    backend mybackend {
        \&.\&.\&.
        \&.\&.\&. // statements that define the
        \&.\&.\&. // backend named \&'mybackend\&'
        \&.\&.\&.
    }
}
.fi 

.PP 
The backend definition statements are shown below\&.
.PP 
.IP "Server:"
Each back end must be identified by the network name
(server name) where it is located\&. For example: \f(CWserver
10\&.1\&.1\&.23\fP, or \f(CWserver web\&.mydomain\&.org\fP\&.
.IP 
.IP o 
Syntax: \f(CWserver\fP \fIservername\fP \f(CW;\fP
.IP o 
There is no default\&. This is a required setting\&.
.IP 
.IP "Port:"
Besides the \f(CWserver\fP specifier, the \f(CWport\fP
definition is also required\&. It has one argument, the (numeric)
port number\&.
.IP 
.IP o 
Syntax: \f(CWport\fP \fInumber\fP \f(CW;\fP
.IP o 
There is no default\&. This is a required setting\&.
.IP 
.IP "Verbosity:"
Similar to \f(CWservice\fP specifications, a
\f(CWbackend\fP can have its own verbosity (\f(CWon\fP or \f(CWoff\fP)\&. When
\f(CWon\fP, traffic to and fro this back end is reported\&.    
.IP 
.IP o 
Syntax: \f(CWverbosity\fP \fIsetting\fP \f(CW;\fP
.IP o 
where \fIsetting\fP is \f(CWtrue\fP, \f(CWyes\fP or \f(CWon\fP to turn
verbosity on; or \f(CWfalse\fP, \f(CWno\fP, \f(CWoff\fP to turn it off\&.
.IP o 
Default: \f(CWoff\fP\&.
.IP 
.IP "Weight:"
To influence how backends are selected by size or by
duration, a backend can specify its \&'weight\&' in the process\&. The
higher the weight, the less likely a back end will be chosen\&. The
default is 1\&.
.IP 
The weighing mechanism only applies for \f(CWdispatchmode bysize\fP or
\f(CWbyduration\fP\&. The weight is in fact a multiplier\&. E\&.g\&., if backend A has
\f(CWweight 2\fP and backend B has \f(CWweight 1\fP, then backend B will
be selected all the time,
until its usage parameter is twice as large as the
parameter of A\&.
.IP 
.IP o 
Syntax: \f(CWweight\fP \fInumber\fP \f(CW;\fP
.IP 
.IP "Decay:"
To make sure that a \&'spike\&' of activity doesn\&'t
influence the perceived load of a back end forever, you may
specify a certain decay\&. E\&.g, the statement \f(CWdecay 10\fP makes
sure that the load that crossroads computes for this back end (be
it in seconds or in bytes) is decreased by 10% each time that
\fBan other\fP back end is hit\&.
.IP 
This means that when a given back end is hit, then its usage data
is updated according to the session\&. However, when a different
back end is hit, its usage is decreased by the specified decay\&.
.IP 
.IP o 
Syntax: \f(CWdecay\fP \fInumber\fP \f(CW;\fP
.IP o 
where \fInumber\fP is a percentage that decreases the back
end usage when other back ends are hit
.IP o 
Default: 0
.IP 
.IP "Event triggers:"
As special \&'hooks\&' for actions, two triggers
are available: \f(CWonfailure\fP and \f(CWonsuccess\fP\&. The argument to
the triggers is a system command that is executed when a session
with the back end either fails or succeeds\&.
.IP 
.IP o 
Syntax: \f(CWonfailure\fP \fIcommandline\fP \f(CW;\fP and
\f(CWonsuccess\fP \fIcommandline\fP \f(CW;\fP
.IP o 
There is no default\&.
.IP 
.IP "Debugging aids:"
Incase the traffic between client and backend
must be debugged, the statement \f(CWdumptraffic\fP \fIfilename\fP can
be issued\&. This causes the traffic to be dumped in hexadecimal
format to the stated filename\&.
.IP 
Traffic sent by the client is prefixed by a \f(CWC\fP, traffic sent by
the back end is prefixed by a \f(CWB\fP\&. Below is a sample traffic
dump of a browser trying to get a HTML page\&. The server replies
that the page was not modified\&.
.IP 
.nf 
C 0000  47 45 54 20 68 74 74 70 3a 2f 2f 77 77 77 2e 63 GET http://www\&.c
C 0010  73 2e 68 65 6c 73 69 6e 6b 69 2e 66 69 2f 6c 69 s\&.helsinki\&.fi/li
C 0020  6e 75 78 2f 6c 69 6e 75 78 2d 6b 65 72 6e 65 6c nux/linux-kernel
C 0030  2f 32 30 30 31 2d 34 37 2f 30 34 31 37 2e 68 74 /2001-47/0417\&.ht
C 0040  6d 6c 20 48 54 54 50 2f 31 2e 31 0d 0a 43 6f 6e ml HTTP/1\&.1\&.\&.Con
C 0050  6e 65 63 74 69 6f 6e 3a 20 63 6c 6f 73 65 0d 0a nection: close\&.\&.
C 0060  55 73 65 72 2d 41 67 65 6e 74 3a 20 4d 6f 7a 69 User-Agent: Mozi
C 0070  6c 6c 61 2f 35 2e 30 20 28 63 6f 6d 70 61 74 69 lla/5\&.0 (compati
C 0080  62 6c 65 3b 20 4b 6f 6e 71 75 65 72 6f 72 2f 33 ble; Konqueror/3
C 0090  2e 33 29 20 28 4b 48 54 4d 4c 2c 20 6c 69 6b 65 \&.3) (KHTML, like
C 00a0  20 47 65 63 6b 6f 29 0d 0a 52 65 66 65 72 65 72  Gecko)\&.\&.Referer
C 00b0  3a 20 68 74 74 70 3a 2f 2f 77 77 77 2e 63 73 2e : http://www\&.cs\&.
C 00c0  68 65 6c 73 69 6e 6b 69 2e 66 69 2f 6c 69 6e 75 helsinki\&.fi/linu
C 00d0  78 2f 6c 69 6e 75 78 2d 6b 65 72 6e 65 6c 2f 32 x/linux-kernel/2
C 00e0  30 30 31 2d 34 37 2f 30 34 31 38 2e 68 74 6d 6c 001-47/0418\&.html
C 00f0  0d 0a 49 66 2d 4e 6f 6e 65 2d 4d 61 74 63 68 3a \&.\&.If-None-Match:
C 0100  20 22 64 65 63 31 61 34 2d 62 63 62 2d 33 63 30  "dec1a4-bcb-3c0
C 0110  32 39 64 30 32 22 0d 0a 49 66 2d 4d 6f 64 69 66 29d02"\&.\&.If-Modif
C 0120  69 65 64 2d 53 69 6e 63 65 3a 20 4d 6f 6e 2c 20 ied-Since: Mon, 
C 0130  32 36 20 4e 6f 76 20 32 30 30 31 20 31 39 3a 35 26 Nov 2001 19:5
C 0140  30 3a 32 36 20 47 4d 54 0d 0a 41 63 63 65 70 74 0:26 GMT\&.\&.Accept
C 0150  3a 20 74 65 78 74 2f 68 74 6d 6c 2c 20 69 6d 61 : text/html, ima
C 0160  67 65 2f 6a 70 65 67 2c 20 69 6d 61 67 65 2f 70 ge/jpeg, image/p
C 0170  6e 67 2c 20 74 65 78 74 2f 2a 2c 20 69 6d 61 67 ng, text/*, imag
C 0180  65 2f 2a 2c 20 2a 2f 2a 0d 0a 41 63 63 65 70 74 e/*, */*\&.\&.Accept
C 0190  2d 45 6e 63 6f 64 69 6e 67 3a 20 78 2d 67 7a 69 -Encoding: x-gzi
C 01a0  70 2c 20 78 2d 64 65 66 6c 61 74 65 2c 20 67 7a p, x-deflate, gz
C 01b0  69 70 2c 20 64 65 66 6c 61 74 65 0d 0a 41 63 63 ip, deflate\&.\&.Acc
C 01c0  65 70 74 2d 43 68 61 72 73 65 74 3a 20 75 74 66 ept-Charset: utf
C 01d0  2d 38 2c 20 75 74 66 2d 38 3b 71 3d 30 2e 35 2c -8, utf-8;q=0\&.5,
C 01e0  20 2a 3b 71 3d 30 2e 35 0d 0a 41 63 63 65 70 74  *;q=0\&.5\&.\&.Accept
C 01f0  2d 4c 61 6e 67 75 61 67 65 3a 20 65 6e 0d 0a 48 -Language: en\&.\&.H
C 0200  6f 73 74 3a 20 77 77 77 2e 63 73 2e 68 65 6c 73 ost: www\&.cs\&.hels
C 0210  69 6e 6b 69 2e 66 69 0d 0a 0d 0a                inki\&.fi\&.\&.\&.\&.
B 0000  48 54 54 50 2f 31 2e 30 20 33 30 34 20 4e 6f 74 HTTP/1\&.0 304 Not
B 0010  20 4d 6f 64 69 66 69 65 64 0d 0a 44 61 74 65 3a  Modified\&.\&.Date:
B 0020  20 54 75 65 2c 20 31 32 20 4a 75 6c 20 32 30 30  Tue, 12 Jul 200
B 0030  35 20 30 39 3a 34 39 3a 34 37 20 47 4d 54 0d 0a 5 09:49:47 GMT\&.\&.
B 0040  43 6f 6e 74 65 6e 74 2d 54 79 70 65 3a 20 74 65 Content-Type: te
B 0050  78 74 2f 68 74 6d 6c 3b 20 63 68 61 72 73 65 74 xt/html; charset
B 0060  3d 69 73 6f 2d 38 38 35 39 2d 31 0d 0a 4c 61 73 =iso-8859-1\&.\&.Las
B 0070  74 2d 4d 6f 64 69 66 69 65 64 3a 20 4d 6f 6e 2c t-Modified: Mon,
B 0080  20 32 36 20 4e 6f 76 20 32 30 30 31 20 31 39 3a  26 Nov 2001 19:
B 0090  35 30 3a 32 36 20 47 4d 54 0d 0a 41 67 65 3a 20 50:26 GMT\&.\&.Age: 
B 00a0  33 32 33 0d 0a 58 2d 43 61 63 68 65 3a 20 48 49 323\&.\&.X-Cache: HI
B 00b0  54 20 66 72 6f 6d 20 78 79 6e 69 78 2e 65 2d 74 T from xynix\&.e-t
B 00c0  75 6e 69 74 79 2e 63 6f 6d 0d 0a 58 2d 43 61 63 unity\&.com\&.\&.X-Cac
B 00d0  68 65 2d 4c 6f 6f 6b 75 70 3a 20 48 49 54 20 66 he-Lookup: HIT f
B 00e0  72 6f 6d 20 78 79 6e 69 78 2e 65 2d 74 75 6e 69 rom xynix\&.e-tuni
B 00f0  74 79 2e 63 6f 6d 3a 33 31 32 38 0d 0a 50 72 6f ty\&.com:3128\&.\&.Pro
B 0100  78 79 2d 43 6f 6e 6e 65 63 74 69 6f 6e 3a 20 63 xy-Connection: c
B 0110  6c 6f 73 65 0d 0a 0d 0a                         lose\&.\&.\&.\&.
.fi 

.IP 
Turning on traffic dumps will \fIsignificantly\fP
slow down crossroads\&.
.IP 
.IP o 
Syntax: \f(CWdumptraffic\fP \fIfilename\fP \f(CW;\fP
.IP o 
There is no default\&.
.IP 

.SH "3\&.4: How back ends are selected in load balancing"

.PP 
In order to tune your load balancing, you\&'ll need to understand how
crossroads computes usage, how weighing works, and so on\&. In this
section we\&'ll focus on \f(CWdispatchmode bysize\fP and \f(CWdispatchmode
byduration\fP only: the other dispatching types are self-explanatory\&.
.PP 

.SH "3\&.4\&.1: Bysize or byduration"

.PP 
As stated before, crossroads doesn\&'t know \&'what a service does\&' and
how to judge whether a given back end is very busy or not\&. You
must therefore give the right hints:
.PP 
.IP o 
In general, a service which is CPU bound, will be more
busy when it takes longer to process a request\&. The dispatch
mode \f(CWbyduration\fP is appropriate here\&.
.IP 
.IP o 
In contrast, a service which is filesystem bound, will be
more busy when more data are transferred\&. The dispatch mode
\f(CWbysize\fP is apppropriate\&.
.IP 
.IP o 
The dispatch mode \f(CWbyduration\fP can also be used when
network latency is an issue\&. E\&.g\&., if your balancer has back
ends that are geograpically distributed, then \f(CWbyduration\fP
would be a good way to select well available back ends\&.
.IP 
.IP o 
Furthermore it is noteworthy that \f(CWdispatchmode
byduration\fP is not usable for interactive processes such as
SSH logins\&. Idle time of a
login adds to the duration, while causing (almost) no
load\&. Mode \f(CWbyduration\fP should only be used for automated
processes that don\&'t wait for user interaction (e\&.g\&., SOAP
calls and other HTTP requests)\&. 
.PP 

.SH "3\&.4\&.2: Averaging size and duration"

.PP 
The configuration statement \f(CWdispatchmode bysize\fP or \f(CWbyduration\fP
allows an optional modifier \f(CWover\fP \fInumber\fP, where the stated
number represents a session count\&. When this modifier is present, then
crossroads will use a moving average over the last \fIn\fP sessions to
compute duration and size figures\&.
.PP 
In the real world you\&'ll always want this modifier\&. E\&.g\&., consider two
back ends that are running for years now, and one of them is suddenly
overloaded and very busy\&. When the \f(CWover\fP modifier is absent, then
the sudden load will hardly show up in the usage figures -- it will
flatten out due to the large usage figures already stored in the years
of service\&.
.PP 
In contrast, when e\&.g\&. \f(CWover 3\fP is in effect, then a sudden load
does show up -- because it highly contributes to the average of three
sessions\&.
.PP 

.SH "3\&.4\&.3: Specifying decays"

.PP 
Decays are also only relevant when crossroads computes the \&'next best
back end\&' by size (bytes) or duration\&. E\&.g\&., imagine two back ends A
and B, both averaged over say 3 sessions\&.
.PP 
Now when back end A is suddenly hit by a large request (a \&'spike\&'),
its average would go up accordingly\&. But the back end would never
again be used, unless B also received a similar spike, because A\&'s
\&'usage data\&' would forever be larger than B\&'s data\&.
.PP 
For that reason, you should in real situations probably always
specify a decay, so that crossroads recovers from spikes\&. The below
configuration illustrates this:
.PP 
.nf 
/* Definition of the service */
service soap {
    /* Local TCP port */
    port 8080;

    /* We\&'ll select back ends by the processing
     * duration
     */
    dispatchmode byduration over 3;

    /* First back end: */
    backend A {
        /* Back end IP address and port */
        server 10\&.1\&.1\&.1;
        port 8080;
        /* When this back end is NOT hit because
         * the other one is less busy, then the
         * usage parameters decay 10% per session
         */
        decay 10;
    }

    /* Second back end: */
    backend B {
        server 10\&.1\&.1\&.2;
        port 8080;
        decay 10;
    }
}
.fi 

.PP 

.SH "3\&.4\&.4: Adjusting the weights"

.PP 
The back end modifier \f(CWweight\fP is useful in situations where your
back ends differ in respect to performance\&. E\&.g,\&. your back ends may
be geographically distributed, and you know that a given back end is
difficult to reach and often experiences network lag\&.
.PP 
Or you may have
one primary back end, a system with a fast CPU and enough memory, and a
small fall-back back end, with a slow CPU and short on memory\&. In that
case you know in advance that the second back end should be used only rarely\&.
.PP 
In such cases you will know in advance that the best performing back ends
should be selected the most often\&. Here\&'s where the \f(CWweight\fP
statement comes in: you can simply increase the weight of the back
ends with the least performance, so that they are selected less
frequently\&.
.PP 
E\&.g\&., consider the following configuration:
.PP 
.nf 
service soap {
    port 8080;
    dispatchmode byduration over 3;
    backend A {
        server 10\&.1\&.1\&.1;
        port 8080;
        decay 20;
    }
    backend B {
        server 10\&.1\&.1\&.2;
        port 8080;
        weight 2;
        decay 10;
    }
    backend C {
        server 10\&.1\&.1\&.3;
        port 8080;
        weight 4;
        decay 5;
    }
}
.fi 

.PP 
This will cause crossroads to select back ends by the processing time,
averaging over the last three sessions\&. However, backend B will kick
in only when its usage is half of the usage of A (back end B is
probably only half as fast as A)\&. Backend C will kick in only when its
usage is a quarter of the usage of A, which is half of the usage of B
(back end C is probably very weak, and just a fall-back system incase
both A and B crash)\&. Note also that A\&'s usage data decay much faster
than B\&'s and C\&'s\&.
.PP 

.SH "3\&.5: Configuration examples"

.PP 
As a general hint, use \f(CWcrossroads sampleconf\fP to view the most
up-to-date examples of configurations\&. The description below shows a
few examples too\&.
.PP 

.SH "3\&.5\&.1: A load balancer for three webserver back ends"

.PP 
The following configuration example binds crossroads to port 80 of the
current server, and distributes the load over three back ends\&. This
configuration shows most of the possible settings\&.
.PP 
.nf 
service www {
    
    /* Port on which we\&'ll listen in this service: required\&. */
    port 8000;

    /* What IP address should this service listen? Default is \&'any\&'\&.
     * Alternatively you can state an explicit IP address, such as
     * 127\&.0\&.0\&.1; that would bind the service only to \&'localhost\&'\&. */
    bindto any;
    
    /* Verbose reporting or not\&. Default is off\&. */    
    verbosity on;
    
    /* Dispatching mode, or: How to select a back end for an incoming
     * request\&. Possible values:
     *   roundrobin: just the next back end in line
     *   random: like roundrobin, but at random to make things more
     *          confusing\&. Probably only good for testing\&.
     *   bysize: The backend that transferred the least nr of bytes
     *          is the next in line\&. As a modifier you can say e\&.g\&.
     *          bysize over 10, meaning that the 10 last sessions will
     *          be used to compute the transfer size, instead of all
     *          transfers\&.
     *   byduration: The backend that was active for the shortest time
     *          is the next in line\&. As a modifier you can say e\&.g\&.
     *          byduration of 10 to compute over the last 10 sessions\&.
     *   byorder: The first available back end is always taken\&.
     */
    dispatchmode byduration over 5;

    /* Interval at which we\&'ll check whether a temporarily unavailable
     * backend has woken up\&.
     */
    revivinginterval 5;
    
    /* TCP backlog of connections\&. Default is 0 (no backlog, one
     * connection may be active)\&.
     */
    backlog 5;
    
    /* For status reporting: a shared memory key\&. Default is the same
     * as the port number, OR-ed by a magic number\&.
     */
    shmkey 8000;

    /* This controls when crossroads should consider a session as
     * finished even when the TCP sockets weren\&'t closed\&. This is to
     * avoid hanging connections that don\&'t do anything\&. NOTE THAT when
     * crossroads cuts off a session due to timeout exceed, this is
     * not marked as a failure, but as a success\&. Default is 0: no timeout\&.
     */
    sessiontimeout 300;

    /* The max number of allowed client sessions\&. When present, connections
     * won\&'t be accepted if the max is about to be exceeded\&. When
     * absent, all connections will be accepted, which might be misused
     * for a DOS attack\&.
     */
    maxclients 300;

    /* Now let\&'s define a couple of back ends\&. Number 1: */
    backend www_backend_1 {
        /* The server and its port, the minimum configuration\&. */
        server httpserver1;
        port 9010;
        /* The \&'decay\&' of usage data of this back end\&. Only relevant
         * when the whole service has \&'dispatchmode bysize\&' or
         * \&'byduration\&'\&. The number is a percentage by which the usage
         * parameter is decreased upon each session of an other back
         * end\&.
         */
        decay 10;
        
        /* To see what\&'s happening in /var/log/messages: */
        verbosity on;
    }

    /* The second one: */
    backend www_backend_2 {
        /* Server and port */
        server httpserver2;
        port 9011;

        /* Verbosity of reporting when this back end is active */
        verbosity on;

        /* Decay */
        decay 10;

        /* Event triggers for system commands upon succesful activation
         * and upon failure\&.
         */
        onsuccess echo \&'success on backend 2\&' | mail root;
        onfailure echo \&'failure on backend 2\&' | mail root;
    }

    /* And yet another one\&.\&. this time we will dump the traffic
     * to a trace file
     */
    backend www_backend_3 {
        server httpserver3;
        verbosity on;
        port 9000;
        verbosity on;
        decay 10;
        dumptraffic /tmp/backend\&.3\&.log;
    }
}
.fi 

.PP 

.SH "3\&.5\&.2: A HTTP forwarder when travelling"

.PP 
As another example, here\&'s my \f(CWcrossroads\&.conf\fP that I use on my
Linux laptop\&. The problem that I face is that I need many HTTP proxy
configurations (at home, at customers\&' sites and so on) but I\&'m too
lazy to reconfigure browsers all the time\&.
.PP 
Here\&'s how it used to be before crossroads:
.PP 
.IP o 
At home, I would surf through a squid proxy on my local
machine\&. The browser proxy setting is then
\f(CWhttp://localhost:3128\fP\&.
.IP 
.IP o 
Sometimes I start up an SSH tunnel to our offices\&. The
tunnel has a local port 3129, and connects to a squid proxy on
our e-tunity server\&. Hence, the browser proxy is then
\f(CWhttp://localhost:3129\fP\&.
.IP 
.IP o 
At a customer\&'s location I need the proxy
\f(CWhttp://10\&.120\&.34\&.113:8080\fP, because they have configured it
so\&.
.IP 
.IP o 
And in yet other instances, I use a HTTP diagnostic tool
\fIcharles\fP that sits between browser and website and shows me
what\&'s happening\&. I run charles on my own machine and it
listens to port 8888, behaving like a proxy\&. The browser
configuration for the proxy is then
\f(CWhttp://localhost:8888\fP\&.
.PP 
Here\&'s how it works with a crossroads configuration:    
.PP 
.IP o 
I have configured my browsers to use
\f(CWhttp://localhost:8080\fP as the proxy\&. For all situations\&.
.IP 
.IP o 
I use the following crossroads configuration, and let
crossroads figure out which proxy backend works, and which
doesn\&'t\&. Note two particularities:
.IP 
.IP o 
The statement \f(CWdispatchmode byorder\fP\&. This
makes sure that once crossroads determines which
backend works, it will stick to it\&. This usage of
crossroads doesn\&'t need to balance over more than one
back end\&.
.IP 
.IP o 
the statement \f(CWbindto 127\&.0\&.0\&.1\fP makes sure
that requests from other interfaces than loopback
won\&'t get serviced\&.
.IP 
.nf 
service HttpProxy {
    port 8080;
    bindto 127\&.0\&.0\&.1;
    verbosity on;
    dispatchmode byorder;
    revivinginterval 15;

    backend Charles {
        server 127\&.0\&.0\&.1;
        port 8888;
        verbosity on;
    }

    backend CustomerProxy {
        server 10\&.120\&.34\&.113;
        port 8080;
        verbosity on;
    }

    backend SshTunnel {
        server 127\&.0\&.0\&.1;
        port 3129;
    }

    backend LocalSquid {
        server 127\&.0\&.0\&.1;
        port 3128;
        verbosity on;
    }
}
.fi 

.PP 
As a final note, the commandline argument \f(CWtell\fP can be used to
influence crossroad\&'s own detection mechanism of back end availability
detection\&. E\&.g\&., if in the above example the back ends \f(CWSshTunnel\fP
and \f(CWLocalSquid\fP are both active, then \f(CWcrossroads tell httpproxy
sshtunnel down\fP will \&'take down\&' the back end \f(CWSshTunnel\fP -- and
will automatically cause crossroads to switch to \f(CWLocalSquid\fP\&.
.PP 

.SH "3\&.5\&.3: SSH login with enforced idle logout"

.PP 
The following example shows how crossroads \&'throttles\&' SSH
logins\&. Connections are accepted on port
22 (the normal SSH port) and forwards these to the actual SSH daemon
which is running on port 2222\&.
.PP 
Note the usage of the
\f(CWsessiontimeout\fP directive\&. This makes sure that users are logged
out after 10 minutes of inactivity\&. Note also the \f(CWmaxclients\fP
setting, this makes sure that no more than 10 concurrent logins occur\&.
.PP 
.nf 
service Ssh {
    port 22;
    backlog 5;
    maxclients 10;
    sessiontimeout 600;
    backend TrueSshDaemon {
        server 127\&.0\&.0\&.1;
        port 2222;
    }
}
.fi 

.PP 

.SH "4: Benchmarking"
As a small benchmark, this section shows how crossroads affects the
transmitting of HTML data when used as an intermediate \&'station\&'
through which all data travels\&.
.PP 

.SH "4\&.1: Environment"

.PP 
The benchmark was run on a system where the following was varied:
.PP 
.IP 1\&.
A website was recursively spidered through a local squid
proxy\&. The spidering was repeated 10 times, the total was recorded\&.
.IP 
.IP 2\&.
Crossroads was placed in front of the squid proxy, and
the website was again recursively spidered\&. Again, the
spidering was repeated 10 times and the total was recorded\&.
.PP 
The crossroads configuration of the second alternative is shown below:
.PP 
.nf 
service HttpProxy {
    port 8080;
    verbosity on;
    backend LocalSquid {
        server 127\&.0\&.0\&.1;
        port 3128;
        verbosity on;
    }
}
.fi 

.PP 

.SH "4\&.2: Results"

.PP 
The results of this test are that crossroads causes a negligible
delay, if it is statistically relevant at all\&. Without crossroads, the
timing results are:
.PP 
.nf 
real	0m8\&.146s
user	0m0\&.130s
sys	0m0\&.253s
.fi 

.PP 
When using crossroads as a middle station, the results are:
.PP 
.nf 
real	0m9\&.481s
user	0m0\&.141s
sys	0m0\&.230s
.fi 

.PP 

.SH "4\&.3: Discussion"

.PP 
The above shown results are quite favorable to crossroads\&. However,
one should know that situations will exist where crossroads leans
towards the \&'worst case\&' scenario, causing up to 50%
delay\&.
.PP 
E\&.g\&., imagine a test where a \f(CWwget\fP command retrieves a
HTML document from an Apache server on \f(CWlocalhost\fP\&. Now we have
(almost) no overhead due to network throttling, hostname lookups and
so on\&. When this test would be run either with or without crossroads
in between, then theoretically, crossroads would cause a much larger
delay, because it has to read from the server, and then write the same
information to \f(CWwget\fP\&.  Each read/write occurs twice when crossroads
sits in between\&.
.PP 
This worst case scenario will however (fortunately) occur only very
seldom in the real world:
.PP 
.IP o 
Normally network issues, such as the above mentioned host
name lookups or throughput restrictions, will add
significantly to the duration of a request\&. The \&'twice as
many\&' read/writes caused by crossroads are then relatively
irrelevant\&.
.IP 
.IP o 
Normally a significant amount of time will be spent in a
back end, due to processing (e\&.g\&., when calling a servlet on a
back end)\&. Again, this processing time will weigh much heavier
than the multiple read/writes\&.
.PP 

.SH "5: Compiling and Installing"


.SH "5\&.1: Prerequisites"

.PP 
The creation of crossroads requires:
.PP 
.IP o 
Standard Unix tools, such as \f(CWsed\fP, \f(CWawk\fP, \f(CWPerl\fP
(5\&.00 or better);
.IP 
.IP o 
A POSIX-compliant C compiler;
.IP 
.IP o 
The grammar generation tools \f(CWbison\fP and \f(CWflex\fP;
.IP 
.IP o 
Support for SYSV IPC, networking and so on\&.

.PP 
Basically a Linux or Apple MacOSX box will do nicely once you make
sure that \f(CWbison\fP and \f(CWflex\fP are installed\&. To compile and install
crossroads, follow these steps\&.
.PP 

.SH "5\&.2: Compiling and installing"

.PP 
.IP o 
Obtain the source distribution\&. It can be found on
http://public\&.e-tunity\&.com\&. The distribution comes as an
archive \f(CWcrossroads-\fP\fIX\&.YY\fP\f(CW\&.tar\&.gz\fP, where \fIX\&.YY\fP is
a version number\&.
.IP 
.IP o 
Unpack the archive in a sources directory using \f(CWtar
xzf crossroads-\fP\fIX\&.YY\fP\f(CW\&.tar\&.gz\fP\&. The contents spill into a
subdirectory \f(CWcrossroads/\fP\&.
.IP 
.IP o 
Change-dir into the directory\&.
.IP 
.IP o 
Next, edit \f(CWetc/Makefile\&.def\fP and verify that all
compilation settings are to your likings\&. The settings are
explained in the file\&. \fBNote that\fP the default distribution
of \f(CWMakefile\&.def\fP is suited for Linux or Apple MacOSX
systems\&.
On other
Unices, or on non-Unix systems, you must particularly pay
attention to \f(CWSET_PROC_TITLE_BY\&.\&.\&.\fP\&. When in doubt, comment out
all \f(CWSET_PROC_TITLE\&.\&.\&.\fP settings\&. Crossroads will work
nevertheless, but it won\&'t show nice titles in \f(CWps\fP listings\&.
.IP 
.IP o 
Now crossroads is ready for compilation\&. Do a \f(CWmake
local\fP followed by \f(CWmake install\fP\&. The latter step may have
to be done by the user \f(CWroot\fP if the \f(CWBINDIR\fP setting of
\f(CWetc/Makefile\&.def\fP points to a root-owned directory\&.
.IP 
.IP o 
The documentation doesn\&'t install in this process\&. If you
want to install the documentation, then proceed as follows:
.IP 
.IP o 
Optionally, \f(CWcp doc/crossroads\&.html\fP
\fIhtmldirectory/\fP; where \fIhtmldirectory\fP is the destination
directory for your HTML manuals;
.IP 
.IP o 
Optionally, \f(CWcp doc/crossroads\&.pdf\fP
\fIpdfdirectory/\fP; where \fIpdfdirectory\fP is the
destination directory for your PDF manuals;
.IP 
.IP o 
Optionally, \f(CWcp doc/crossroads\&.man\fP
\fImanualdirectory\fP\f(CW/man1/crossroads\&.1\fP, where
\fImanualdirectory\fP is e\&.g\&. \f(CW/usr/man\fP,
\f(CW/usr/share\fP, \f(CW/usr/local/man\fP,
\f(CW/usr/local/share\fP\&. Any possibility is valid, as
long as \f(CWmanualdirectory\fP has a subdirectory
\f(CWman1/\fP;
.IP 
.IP o 
If your manual page system supports compressed
manual pages, then you can save some space with
\f(CWgzip -c < doc/crossroads\&.man >\fP
\fImanualdirectory\fP\f(CW/man1/crossroads\&.1\&.gz\fP\&.
.IP 

.SH "5\&.3: Configuring crossroads"

.PP 
Now that the binary is available on your system, you need to create a
suitable \f(CW/etc/crossroads\&.conf\fP\&. Use this manual or the output of
\f(CWcrossroads samplconf\fP to get started\&.
.PP 
Once you have the configuration ready, start crossroads with
\f(CWcrossroads start\fP\&. Test the availability of your services and back
ends\&. Monitor how crossroads is doing with:
.PP 
.IP o 
In one terminal, run the script:
.nf 
while [ 1 ] ; do
    tput clear
    crossroads status
    sleep 3
done
.fi 

.IP 
.IP o 
In another terminal, run:
.nf 
while [ 1 ] ; do
    tput clear
    ps ax | grep crossroads | grep -v grep
    sleep 3		    	
done
.fi 

.IP 
.IP o 
In yet another terminal, run \f(CWtail -f /var/log/messages\fP\&.
.PP 
Now thoroughly test the availability of your back ends through
crossroads\&. The status display will show an updated view of which back
ends are selected and how busy they are\&. The process list will show
which crossroads daemons are running\&. Finally, the tailing of
\f(CW/var/log/messages\fP shows what\&'s going on -- especially if you have
\f(CWverbosity true\fP statements in the configuration\&.
.PP 

.SH "5\&.4: A boot script"

.PP 
Finally, you may want to create a boot-time startup script\&. The exact
procedure depends on the used Unix flavor\&.
.PP 

.SH "5\&.4\&.1: SysV Style Startup"

.PP 
On SysV style systems, there\&'s a startup script directory
\f(CW/etc/init\&.d\fP where bootscripts for all utilities are located\&.
You may have the \f(CWchkconfig\fP utility to automate the task of
inserting scripts into the boot sequence, but
otherwise the steps will resemble the following\&.
.PP 
.IP o 
Create a script \f(CWcrossroads\fP in \f(CW/etc/init\&.d\fP similar to the
following:
.IP 
.nf 
#!/bin/sh
/usr/local/bin/crossroads -v $@
.fi 

.IP 
The stated directory \f(CW/usr/local/bin\fP must correspond with
the installation path\&. The flag \f(CW-v\fP causes the startup to
be more \&'verbose\&'\&. However, once daemonized, the verbosity is
controlled by the appropriate statements in the configuration\&.
.IP 
.IP o 
Determine your \&'runlevel\&': usually 3 when your system is
running in text-mode only, or 5 when you are a graphical
interface\&. If your runlevel is 3, then:
.IP 
.nf 
root> cd /etc/rc\&.d/rc3\&.d
root> ln -s /etc/init\&.d/crossroads S99crossroads
root> ln -s /etc/init\&.d/crossroads K99crossroads
.fi 

.IP 
This creates startup (\f(CWS*\fP) and stop (\f(CWK*\fP) links that
will be run when the system enters or leaves a given runlevel\&.
.IP 
If your runlevel is 5, then the right \f(CWcd\fP command is to
\f(CW/etc/rc\&.d/rc5\&.d\fP\&. Alternatively, you can create the
symlinks in both runlevel directories\&.
.PP 

.SH "5\&.4\&.2: BSD Style Startup"

.PP 
On BSD style systems, daemons are booted directly from \f(CW/etc/rc\fP and
related scripts\&. Incase you have a file \f(CW/etc/rc\&.local\fP, edit it,
and add the statement:
.PP 
.nf 
/usr/local/bin/crossroads start
.fi 

.PP 
If your BSD system lacks \f(CW/etc/rc\&.local\fP, then you may need to start
Crossroads from \f(CW/etc/rc\fP\&. Your mileage may vary\&.
.PP 
