#include "crossroads.h"

void dumptraffic (char const *buf, int len, int isclient) {
    int i, j, n = 0;
    char disp[17];
    FILE *f;

    if (! activeservice->backend[current_backend].dumpfile)
	return;

    if ( (! (f = fopen (activeservice->backend[current_backend].dumpfile,
			"a"))) &&
	 (! (f = fopen (activeservice->backend[current_backend].dumpfile,
			"w"))) ) {
	warning ("Cannot write %s: %s",
		 activeservice->backend[current_backend].dumpfile,
		 strerror(errno));
	return;
    }

    flock (fileno(f), LOCK_EX);
    
    for (i = 0; i < len; i++) {
	if (! n) 
	    fprintf (f, "%c %4.4x ", isclient ? 'C' : 'B', i);
	fprintf (f, " %2.2x", buf[i]);
	disp[n] = isprint(buf[i]) ? buf[i] : '.';

	n++;

	if (n == 16) {
	    fputc (' ', f);
	    for (j = 0; j < n; j++)
		fputc (disp[j], f);
	    fputc ('\n', f);
	    n = 0;
	}
    }

    for (j = n; j < 16; j++)
	fprintf (f, "   ");
    fputc (' ', f);
    for (j = 0; j < n; j++)
	fputc (disp[j], f);
    fputc ('\n', f);
    
    flock (fileno(f), LOCK_UN);
    fclose (f);
}
