    
#include "crossroads.h"

int make_socket (int port, char const *ipaddr) {
    int sock, val = 1;
    struct sockaddr_in name;

    /* Create the socket. */
    if ( (sock = socket (PF_INET, SOCK_STREAM, 0)) < 0)
	error ("Cannot create network socket: %s", strerror(errno));
    if (setsockopt (sock, SOL_SOCKET, SO_REUSEADDR, &val, sizeof(val)))
	error ("Cannot set socket options: %s", strerror(errno));

    /* Give the socket a name. */
    name.sin_family = AF_INET;
    name.sin_port = htons (port);

    /* Propagate 'bindto' if given. */
    if (strcasecmp (ipaddr, "any")) {
	msg ("Creating socket for IP address '%s'", ipaddr);
	if ( (name.sin_addr.s_addr = inet_addr (ipaddr)) == INADDR_NONE )
	    error ("Cannot convert address '%s' to network bytes",
		   ipaddr);
    } else {
	msg ("Creating socket for all interfaces");
	name.sin_addr.s_addr = htonl (INADDR_ANY);
    }

    /* Finallly, bind the socket. */
    if (bind (sock, (struct sockaddr *) &name, sizeof (name)) < 0)
	error ("Cannot bind socket to port %d: %s", port, strerror(errno));

    return (sock);
}
