#include "crossroads.h"

void restart (int ac, char **av) {
    char *cmd = 0;
    int i, ret;

    /* First run the 'stop' action. */
    for (i = 0; i < org_argc - 1; i++) {
	cmd = xstrcat (cmd, org_argv[i]);
	cmd = xstrcat (cmd, " ");
    }
    cmd = xstrcat (cmd, "stop");

    msg ("Restart: stopping using '%s'\n", cmd);
    if ( (ret = system (cmd)) )
	error ("Failed to stop services (cmd: %s).\n"
	       "Crossroads may be in an unstable state, fix by hand!\n",
	       cmd);

    /* Wait a few secs to allow the listening socket to free up. */
    sleep (1);

    /* Now run the 'start' action */
    org_argv[org_argc - 1] = "start";
    free (cmd);
    cmd = 0;
    for (i = 0; i < org_argc; i++) {
	cmd = xstrcat (cmd, org_argv[i]);
	if (i < org_argc - 1)
	    cmd = xstrcat (cmd, " ");
    }
    msg ("Restart: starting using '%s'\n", cmd);
    
    // execvp (org_argv[0], org_argv);
    if ( (ret = system (cmd)) )
	error ("Failed to start services (cmd: %s).\n"
	       "Crossroads is not running, fix by hand!\n");
}
