#include "crossroads.h"

void serve (int ac, char **av) {
    int i;
    
    msg ("Starting services");

    /* Here's a dirty hack for Linux systems. We're going to get
     * daemonized (unless -f was given) and we'll want to change the
     * program name as it appears in the ps list.
     * So we re-exec ourselves with a dummy -i flag that creates
     * space on the commanedline.
     */
#   ifdef SET_PROC_TITLE_BY_ARGV
    if (! flag_foreground && ! iflag_present) {
	char **argv = xmalloc ( (org_argc + 1) * sizeof(char*));
	int i;
	
	argv[0] = org_argv[0];
	argv[1] = "-i xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
	          "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";
	argv[org_argc + 1] = 0;

	for (i = 1; i < org_argc; i++)
	    argv[i + 1] = org_argv[i];

	execv (argv[0], argv);
	execvp (argv[0], argv);
	error ("Failed to re-exec program: %s",
	       strerror(errno));
    }
#   endif
    
    for (i = 0; i < nservice; i++) {
	/* With -f flag, don't run second and next services. */
	if (i && flag_foreground)
	    break;

	/* Start the service. */
	activeservice = service + i;
	runservice ();
    }
}
