#include "crossroads.h"

void set_program_title (char const *fmt, ...) {
    static int orglen;
    char *title;
    int i;
    va_list args;    

    /* Make the title */
    va_start (args, fmt);
    title = str_vprintf (fmt, args);
    va_end (args);

#   ifdef SET_PROC_TITLE_BY_ARGV
    /* Reset old argv, count max length */
    if (! orglen)
	for (i = 0; i < org_argc; i++)
	    orglen += (strlen(org_argv[i]) + 1);

    /* Paste in the new title */
    for (i = 0; i < strlen(title) && i < orglen; i++)
	org_argv[0][i] = title[i];
    for (i = strlen(title); i < orglen; i++)
	org_argv[0][i] = 0;
#   endif  /* SET_PROC_TITLE_BY_ARGV */

    /* Free up */
    free (title);
}
