#include "crossroads.h"

void stop_daemon (int ac, char **av) {
    int i, ret = 0;

    for (i = 0; i < nservice; i++) {
	alloc_reporter (service + i, 0);
	msg ("Stopping service %s (daemon pid %d, wakeup handler pid %d)\n",
	     service[i].name, servicereport->pid, servicereport->rev_pid);
	if (kill (servicereport->pid, SIGINT)) {
	    warning ("Failed to stop service %s (%s)\n",
		     service[i].name, strerror(errno));
	    ret++;
	}
	if (servicereport->rev_pid && kill (servicereport->rev_pid, SIGINT)) {
	    warning ("Failed to stop wakeup handler of service %s (%s)\n",
		     service[i].name, strerror(errno));
	    ret++;
	}
	
	/* Note: We run the deallocator of shmem here anyeay, though the
	 * signalled listener does it too.. just to make sure..
	 */
	dealloc_reporter (service + i);
    }

    exit (ret);
}
